unit ThrobbingLabelImpl;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ActiveX, AxCtrls, ThrobbingLabelProj_TLB, ExtCtrls, StdCtrls;

type
  TThrobbingLabelX = class(TActiveForm, IThrobbingLabelX)
    Label1: TLabel;
    Timer1: TTimer;
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
    FEvents: IThrobbingLabelXEvents;
    procedure ActivateEvent(Sender: TObject);
    procedure ClickEvent(Sender: TObject);
    procedure CreateEvent(Sender: TObject);
    procedure DblClickEvent(Sender: TObject);
    procedure DeactivateEvent(Sender: TObject);
    procedure DestroyEvent(Sender: TObject);
    procedure KeyPressEvent(Sender: TObject; var Key: Char);
    procedure PaintEvent(Sender: TObject);
  protected
    { Protected declarations }
    procedure EventSinkChanged(const EventSink: IUnknown); override;
    procedure Initialize; override;
    function Get_Active: WordBool; safecall;
    function Get_AutoScroll: WordBool; safecall;
    function Get_AxBorderStyle: TxActiveFormBorderStyle; safecall;
    function Get_Caption: WideString; safecall;
    function Get_Color: TColor; safecall;
    function Get_Cursor: Smallint; safecall;
    function Get_DropTarget: WordBool; safecall;
    function Get_Enabled: WordBool; safecall;
    function Get_Font: Font; safecall;
    function Get_HelpFile: WideString; safecall;
    function Get_KeyPreview: WordBool; safecall;
    function Get_PixelsPerInch: Integer; safecall;
    function Get_PrintScale: TxPrintScale; safecall;
    function Get_Scaled: WordBool; safecall;
    function Get_Visible: WordBool; safecall;
    function Get_WindowState: TxWindowState; safecall;
    procedure Set_AutoScroll(Value: WordBool); safecall;
    procedure Set_AxBorderStyle(Value: TxActiveFormBorderStyle); safecall;
    procedure Set_Caption(const Value: WideString); safecall;
    procedure Set_Color(Value: TColor); safecall;
    procedure Set_Cursor(Value: Smallint); safecall;
    procedure Set_DropTarget(Value: WordBool); safecall;
    procedure Set_Enabled(Value: WordBool); safecall;
    procedure Set_Font(const Value: Font); safecall;
    procedure Set_HelpFile(const Value: WideString); safecall;
    procedure Set_KeyPreview(Value: WordBool); safecall;
    procedure Set_PixelsPerInch(Value: Integer); safecall;
    procedure Set_PrintScale(Value: TxPrintScale); safecall;
    procedure Set_Scaled(Value: WordBool); safecall;
    procedure Set_Visible(Value: WordBool); safecall;
    procedure Set_WindowState(Value: TxWindowState); safecall;
  public
    { Public declarations }
  end;

implementation

uses ComServ;

{$R *.DFM}

{ TThrobbingLabelX }

procedure TThrobbingLabelX.EventSinkChanged(const EventSink: IUnknown);
begin
  FEvents := EventSink as IThrobbingLabelXEvents;
end;

procedure TThrobbingLabelX.Initialize;
begin
  OnActivate := ActivateEvent;
  OnClick := ClickEvent;
  OnCreate := CreateEvent;
  OnDblClick := DblClickEvent;
  OnDeactivate := DeactivateEvent;
  OnDestroy := DestroyEvent;
  OnKeyPress := KeyPressEvent;
  OnPaint := PaintEvent;
end;

function TThrobbingLabelX.Get_Active: WordBool;
begin
  Result := Active;
end;

function TThrobbingLabelX.Get_AutoScroll: WordBool;
begin
  Result := AutoScroll;
end;

function TThrobbingLabelX.Get_AxBorderStyle: TxActiveFormBorderStyle;
begin
  Result := Ord(AxBorderStyle);
end;

function TThrobbingLabelX.Get_Caption: WideString;
begin
  Result := WideString(Caption);
end;

function TThrobbingLabelX.Get_Color: TColor;
begin
  Result := Color;
end;

function TThrobbingLabelX.Get_Cursor: Smallint;
begin
  Result := Smallint(Cursor);
end;

function TThrobbingLabelX.Get_DropTarget: WordBool;
begin
  Result := DropTarget;
end;

function TThrobbingLabelX.Get_Enabled: WordBool;
begin
  Result := Enabled;
end;

function TThrobbingLabelX.Get_Font: Font;
begin
  GetOleFont(Font, Result);
end;

function TThrobbingLabelX.Get_HelpFile: WideString;
begin
  Result := WideString(HelpFile);
end;

function TThrobbingLabelX.Get_KeyPreview: WordBool;
begin
  Result := KeyPreview;
end;

function TThrobbingLabelX.Get_PixelsPerInch: Integer;
begin
  Result := PixelsPerInch;
end;

function TThrobbingLabelX.Get_PrintScale: TxPrintScale;
begin
  Result := Ord(PrintScale);
end;

function TThrobbingLabelX.Get_Scaled: WordBool;
begin
  Result := Scaled;
end;

function TThrobbingLabelX.Get_Visible: WordBool;
begin
  Result := Visible;
end;

function TThrobbingLabelX.Get_WindowState: TxWindowState;
begin
  Result := Ord(WindowState);
end;

procedure TThrobbingLabelX.Set_AutoScroll(Value: WordBool);
begin
  AutoScroll := Value;
end;

procedure TThrobbingLabelX.Set_AxBorderStyle(
  Value: TxActiveFormBorderStyle);
begin
  AxBorderStyle := TActiveFormBorderStyle(Value);
end;

procedure TThrobbingLabelX.Set_Caption(const Value: WideString);
begin
  Caption := TCaption(Value);
end;

procedure TThrobbingLabelX.Set_Color(Value: TColor);
begin
  Color := Value;
end;

procedure TThrobbingLabelX.Set_Cursor(Value: Smallint);
begin
  Cursor := TCursor(Value);
end;

procedure TThrobbingLabelX.Set_DropTarget(Value: WordBool);
begin
  DropTarget := Value;
end;

procedure TThrobbingLabelX.Set_Enabled(Value: WordBool);
begin
  Enabled := Value;
end;

procedure TThrobbingLabelX.Set_Font(const Value: Font);
begin
  SetOleFont(Font, Value);
end;

procedure TThrobbingLabelX.Set_HelpFile(const Value: WideString);
begin
  HelpFile := String(Value);
end;

procedure TThrobbingLabelX.Set_KeyPreview(Value: WordBool);
begin
  KeyPreview := Value;
end;

procedure TThrobbingLabelX.Set_PixelsPerInch(Value: Integer);
begin
  PixelsPerInch := Value;
end;

procedure TThrobbingLabelX.Set_PrintScale(Value: TxPrintScale);
begin
  PrintScale := TPrintScale(Value);
end;

procedure TThrobbingLabelX.Set_Scaled(Value: WordBool);
begin
  Scaled := Value;
end;

procedure TThrobbingLabelX.Set_Visible(Value: WordBool);
begin
  Visible := Value;
end;

procedure TThrobbingLabelX.Set_WindowState(Value: TxWindowState);
begin
  WindowState := TWindowState(Value);
end;

procedure TThrobbingLabelX.ActivateEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnActivate;
end;

procedure TThrobbingLabelX.ClickEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnClick;
end;

procedure TThrobbingLabelX.CreateEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnCreate;
end;

procedure TThrobbingLabelX.DblClickEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDblClick;
end;

procedure TThrobbingLabelX.DeactivateEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDeactivate;
end;

procedure TThrobbingLabelX.DestroyEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDestroy;
end;

procedure TThrobbingLabelX.KeyPressEvent(Sender: TObject; var Key: Char);
var
  TempKey: Smallint;
begin
  TempKey := Smallint(Key);
  if FEvents <> nil then FEvents.OnKeyPress(TempKey);
  Key := Char(TempKey);
end;

procedure TThrobbingLabelX.PaintEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnPaint;
end;


procedure TThrobbingLabelX.Timer1Timer(Sender: TObject);
const
  MaxSize = 80;
  MinSize = 8;
  Size: Integer = MinSize;
  Increment: Integer = 1;
begin
  Inc(Size, Increment);
  Label1.Font.Size := Size;
  Label1.Font.Color := RGB(Random(256), Random(256), Random(256));
  if (Size >= MaxSize) or (Size <= MinSize) then
    Increment := -Increment
end;

initialization
  Randomize;
  TActiveFormFactory.Create(
    ComServer,
    TActiveFormControl,
    TThrobbingLabelX,
    Class_ThrobbingLabelX,
    1,
    '',
    OLEMISC_SIMPLEFRAME or OLEMISC_ACTSLIKELABEL);
end.
